/* PageChecker.c generated by valac 0.56.8, the Vala compiler
 * generated from PageChecker.vala, do not modify */

/*
 * Copyright (c) 2017-2019 elementary, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <adwaita.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define ONBOARDING_PAGE_CHECKER_MIN_OPACITY 0.4
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define ONBOARDING_TYPE_PAGE_CHECKER (onboarding_page_checker_get_type ())
#define ONBOARDING_PAGE_CHECKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONBOARDING_TYPE_PAGE_CHECKER, OnboardingPageChecker))
#define ONBOARDING_PAGE_CHECKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONBOARDING_TYPE_PAGE_CHECKER, OnboardingPageCheckerClass))
#define ONBOARDING_IS_PAGE_CHECKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONBOARDING_TYPE_PAGE_CHECKER))
#define ONBOARDING_IS_PAGE_CHECKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONBOARDING_TYPE_PAGE_CHECKER))
#define ONBOARDING_PAGE_CHECKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONBOARDING_TYPE_PAGE_CHECKER, OnboardingPageCheckerClass))

typedef struct _OnboardingPageChecker OnboardingPageChecker;
typedef struct _OnboardingPageCheckerClass OnboardingPageCheckerClass;
typedef struct _OnboardingPageCheckerPrivate OnboardingPageCheckerPrivate;

#define TYPE_ABSTRACT_ONBOARDING_VIEW (abstract_onboarding_view_get_type ())
#define ABSTRACT_ONBOARDING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_ONBOARDING_VIEW, AbstractOnboardingView))
#define ABSTRACT_ONBOARDING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_ONBOARDING_VIEW, AbstractOnboardingViewClass))
#define IS_ABSTRACT_ONBOARDING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_ONBOARDING_VIEW))
#define IS_ABSTRACT_ONBOARDING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_ONBOARDING_VIEW))
#define ABSTRACT_ONBOARDING_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_ONBOARDING_VIEW, AbstractOnboardingViewClass))

typedef struct _AbstractOnboardingView AbstractOnboardingView;
typedef struct _AbstractOnboardingViewClass AbstractOnboardingViewClass;
enum  {
	ONBOARDING_PAGE_CHECKER_0_PROPERTY,
	ONBOARDING_PAGE_CHECKER_CAROUSEL_PROPERTY,
	ONBOARDING_PAGE_CHECKER_PAGE_PROPERTY,
	ONBOARDING_PAGE_CHECKER_NUM_PROPERTIES
};
static GParamSpec* onboarding_page_checker_properties[ONBOARDING_PAGE_CHECKER_NUM_PROPERTIES];

struct _OnboardingPageChecker {
	GtkButton parent_instance;
	OnboardingPageCheckerPrivate * priv;
};

struct _OnboardingPageCheckerClass {
	GtkButtonClass parent_class;
};

struct _OnboardingPageCheckerPrivate {
	AdwCarousel* _carousel;
	AbstractOnboardingView* _page;
	gint page_number;
};

static gint OnboardingPageChecker_private_offset;
static gpointer onboarding_page_checker_parent_class = NULL;

VALA_EXTERN GType onboarding_page_checker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnboardingPageChecker, g_object_unref)
VALA_EXTERN GType abstract_onboarding_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AbstractOnboardingView, g_object_unref)
VALA_EXTERN OnboardingPageChecker* onboarding_page_checker_new (AdwCarousel* carousel,
                                                    AbstractOnboardingView* page);
VALA_EXTERN OnboardingPageChecker* onboarding_page_checker_construct (GType object_type,
                                                          AdwCarousel* carousel,
                                                          AbstractOnboardingView* page);
static void onboarding_page_checker_update_opacity (OnboardingPageChecker* self);
VALA_EXTERN AdwCarousel* onboarding_page_checker_get_carousel (OnboardingPageChecker* self);
static void onboarding_page_checker_set_carousel (OnboardingPageChecker* self,
                                           AdwCarousel* value);
VALA_EXTERN AbstractOnboardingView* onboarding_page_checker_get_page (OnboardingPageChecker* self);
static void onboarding_page_checker_set_page (OnboardingPageChecker* self,
                                       AbstractOnboardingView* value);
static GObject * onboarding_page_checker_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
VALA_EXTERN const gchar* abstract_onboarding_view_get_title (AbstractOnboardingView* self);
static void _onboarding_page_checker___lambda12_ (OnboardingPageChecker* self);
static void __onboarding_page_checker___lambda12__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self);
static void _onboarding_page_checker___lambda13_ (OnboardingPageChecker* self);
static void __onboarding_page_checker___lambda13__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _onboarding_page_checker___lambda14_ (OnboardingPageChecker* self);
static void __onboarding_page_checker___lambda14__gtk_widget_destroy (GtkWidget* _sender,
                                                               gpointer self);
static void onboarding_page_checker_finalize (GObject * obj);
static GType onboarding_page_checker_get_type_once (void);
static void _vala_onboarding_page_checker_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_onboarding_page_checker_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
onboarding_page_checker_get_instance_private (OnboardingPageChecker* self)
{
	return G_STRUCT_MEMBER_P (self, OnboardingPageChecker_private_offset);
}

OnboardingPageChecker*
onboarding_page_checker_construct (GType object_type,
                                   AdwCarousel* carousel,
                                   AbstractOnboardingView* page)
{
	OnboardingPageChecker * self = NULL;
	g_return_val_if_fail (carousel != NULL, NULL);
	g_return_val_if_fail (page != NULL, NULL);
	self = (OnboardingPageChecker*) g_object_new (object_type, "carousel", carousel, "page", page, NULL);
	return self;
}

OnboardingPageChecker*
onboarding_page_checker_new (AdwCarousel* carousel,
                             AbstractOnboardingView* page)
{
	return onboarding_page_checker_construct (ONBOARDING_TYPE_PAGE_CHECKER, carousel, page);
}

static void
onboarding_page_checker_update_opacity (OnboardingPageChecker* self)
{
	gdouble progress = 0.0;
	AdwCarousel* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_carousel;
	_tmp1_ = adw_carousel_get_position (_tmp0_);
	_tmp2_ = _tmp1_;
	progress = MAX (1 - fabs (_tmp2_ - self->priv->page_number), (gdouble) 0);
	gtk_widget_set_opacity ((GtkWidget*) self, ONBOARDING_PAGE_CHECKER_MIN_OPACITY + ((1 - ONBOARDING_PAGE_CHECKER_MIN_OPACITY) * progress));
}

AdwCarousel*
onboarding_page_checker_get_carousel (OnboardingPageChecker* self)
{
	AdwCarousel* result;
	AdwCarousel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_carousel;
	result = _tmp0_;
	return result;
}

static void
onboarding_page_checker_set_carousel (OnboardingPageChecker* self,
                                      AdwCarousel* value)
{
	AdwCarousel* old_value;
	g_return_if_fail (self != NULL);
	old_value = onboarding_page_checker_get_carousel (self);
	if (old_value != value) {
		self->priv->_carousel = value;
		g_object_notify_by_pspec ((GObject *) self, onboarding_page_checker_properties[ONBOARDING_PAGE_CHECKER_CAROUSEL_PROPERTY]);
	}
}

AbstractOnboardingView*
onboarding_page_checker_get_page (OnboardingPageChecker* self)
{
	AbstractOnboardingView* result;
	AbstractOnboardingView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page;
	result = _tmp0_;
	return result;
}

static void
onboarding_page_checker_set_page (OnboardingPageChecker* self,
                                  AbstractOnboardingView* value)
{
	AbstractOnboardingView* old_value;
	g_return_if_fail (self != NULL);
	old_value = onboarding_page_checker_get_page (self);
	if (old_value != value) {
		self->priv->_page = value;
		g_object_notify_by_pspec ((GObject *) self, onboarding_page_checker_properties[ONBOARDING_PAGE_CHECKER_PAGE_PROPERTY]);
	}
}

static void
_onboarding_page_checker___lambda12_ (OnboardingPageChecker* self)
{
	AdwCarousel* _tmp0_;
	AbstractOnboardingView* _tmp1_;
	_tmp0_ = self->priv->_carousel;
	_tmp1_ = self->priv->_page;
	adw_carousel_scroll_to (_tmp0_, (GtkWidget*) _tmp1_, TRUE);
}

static void
__onboarding_page_checker___lambda12__gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self)
{
	_onboarding_page_checker___lambda12_ ((OnboardingPageChecker*) self);
}

static void
_onboarding_page_checker___lambda13_ (OnboardingPageChecker* self)
{
	onboarding_page_checker_update_opacity (self);
}

static void
__onboarding_page_checker___lambda13__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
	_onboarding_page_checker___lambda13_ ((OnboardingPageChecker*) self);
}

static void
_onboarding_page_checker___lambda14_ (OnboardingPageChecker* self)
{
	g_signal_emit_by_name ((GtkWidget*) self, "destroy");
}

static void
__onboarding_page_checker___lambda14__gtk_widget_destroy (GtkWidget* _sender,
                                                          gpointer self)
{
	_onboarding_page_checker___lambda14_ ((OnboardingPageChecker*) self);
}

static GObject *
onboarding_page_checker_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	OnboardingPageChecker * self;
	AbstractOnboardingView* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	AdwCarousel* _tmp9_;
	AbstractOnboardingView* _tmp10_;
	parent_class = G_OBJECT_CLASS (onboarding_page_checker_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONBOARDING_TYPE_PAGE_CHECKER, OnboardingPageChecker);
	gtk_button_set_icon_name ((GtkButton*) self, "pager-checked-symbolic");
	_tmp0_ = self->priv->_page;
	_tmp1_ = abstract_onboarding_view_get_title (_tmp0_);
	_tmp2_ = _tmp1_;
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp2_);
	{
		gint item_count = 0;
		item_count = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				AdwCarousel* _tmp5_;
				AdwCarousel* _tmp6_;
				GtkWidget* _tmp7_;
				AbstractOnboardingView* _tmp8_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = item_count;
					item_count = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = self->priv->_carousel;
				if (!(((guint) item_count) < adw_carousel_get_n_pages (_tmp5_))) {
					break;
				}
				_tmp6_ = self->priv->_carousel;
				_tmp7_ = adw_carousel_get_nth_page (_tmp6_, (guint) item_count);
				_tmp8_ = self->priv->_page;
				if (_tmp7_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget)) {
					self->priv->page_number = item_count;
					break;
				}
			}
		}
	}
	onboarding_page_checker_update_opacity (self);
	g_signal_connect_object ((GtkButton*) self, "clicked", (GCallback) __onboarding_page_checker___lambda12__gtk_button_clicked, self, 0);
	_tmp9_ = self->priv->_carousel;
	g_signal_connect_object ((GObject*) _tmp9_, "notify::position", (GCallback) __onboarding_page_checker___lambda13__g_object_notify, self, 0);
	_tmp10_ = self->priv->_page;
	g_signal_connect_object ((GtkWidget*) _tmp10_, "destroy", (GCallback) __onboarding_page_checker___lambda14__gtk_widget_destroy, self, 0);
	return obj;
}

static void
onboarding_page_checker_class_init (OnboardingPageCheckerClass * klass,
                                    gpointer klass_data)
{
	onboarding_page_checker_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &OnboardingPageChecker_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_onboarding_page_checker_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_onboarding_page_checker_set_property;
	G_OBJECT_CLASS (klass)->constructor = onboarding_page_checker_constructor;
	G_OBJECT_CLASS (klass)->finalize = onboarding_page_checker_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ONBOARDING_PAGE_CHECKER_CAROUSEL_PROPERTY, onboarding_page_checker_properties[ONBOARDING_PAGE_CHECKER_CAROUSEL_PROPERTY] = g_param_spec_object ("carousel", "carousel", "carousel", adw_carousel_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ONBOARDING_PAGE_CHECKER_PAGE_PROPERTY, onboarding_page_checker_properties[ONBOARDING_PAGE_CHECKER_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", TYPE_ABSTRACT_ONBOARDING_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
onboarding_page_checker_instance_init (OnboardingPageChecker * self,
                                       gpointer klass)
{
	self->priv = onboarding_page_checker_get_instance_private (self);
}

static void
onboarding_page_checker_finalize (GObject * obj)
{
	OnboardingPageChecker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONBOARDING_TYPE_PAGE_CHECKER, OnboardingPageChecker);
	G_OBJECT_CLASS (onboarding_page_checker_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
onboarding_page_checker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OnboardingPageCheckerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) onboarding_page_checker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnboardingPageChecker), 0, (GInstanceInitFunc) onboarding_page_checker_instance_init, NULL };
	GType onboarding_page_checker_type_id;
	onboarding_page_checker_type_id = g_type_register_static (gtk_button_get_type (), "OnboardingPageChecker", &g_define_type_info, 0);
	OnboardingPageChecker_private_offset = g_type_add_instance_private (onboarding_page_checker_type_id, sizeof (OnboardingPageCheckerPrivate));
	return onboarding_page_checker_type_id;
}

GType
onboarding_page_checker_get_type (void)
{
	static volatile gsize onboarding_page_checker_type_id__once = 0;
	if (g_once_init_enter (&onboarding_page_checker_type_id__once)) {
		GType onboarding_page_checker_type_id;
		onboarding_page_checker_type_id = onboarding_page_checker_get_type_once ();
		g_once_init_leave (&onboarding_page_checker_type_id__once, onboarding_page_checker_type_id);
	}
	return onboarding_page_checker_type_id__once;
}

static void
_vala_onboarding_page_checker_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	OnboardingPageChecker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ONBOARDING_TYPE_PAGE_CHECKER, OnboardingPageChecker);
	switch (property_id) {
		case ONBOARDING_PAGE_CHECKER_CAROUSEL_PROPERTY:
		g_value_set_object (value, onboarding_page_checker_get_carousel (self));
		break;
		case ONBOARDING_PAGE_CHECKER_PAGE_PROPERTY:
		g_value_set_object (value, onboarding_page_checker_get_page (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_onboarding_page_checker_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	OnboardingPageChecker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ONBOARDING_TYPE_PAGE_CHECKER, OnboardingPageChecker);
	switch (property_id) {
		case ONBOARDING_PAGE_CHECKER_CAROUSEL_PROPERTY:
		onboarding_page_checker_set_carousel (self, g_value_get_object (value));
		break;
		case ONBOARDING_PAGE_CHECKER_PAGE_PROPERTY:
		onboarding_page_checker_set_page (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

